<?
/******************************************************************************
* Topic overview static page
* Version 2.2
* made in 2005 by Oliver Spiesshofer, http://tokyoahead.com / oliver@spiesshofer.com
* questions, comments, suggestions, whatever welcome.
*
* This code shows an overview of all topics that the current user is supposed to see,
* together with the icon of the topic and a link to the topics storylist.
* The code is derived from functions in lib_common.php.
*
* IF YOU USE THIS CODE:
* Please be so kind to submit a link to the static page in the links section at
* tokyoahead.com: http://tokyoahead.com/main/links.php?category=Topic+Overview+Users
* and, if you have a fitting category on your site, maybe link back to tokyoahead
*
* Paste this code without the <? ?> into a static page and set it to encode PHP,
* and set it to return type. Then, set the values in the settings below.
*
* Version 2.2
* - added dimension setting for icons so you can shring them!
*
* Version 2.1
* - minor html corrections
* - optional rewrap for css-option
* - code tuning
* - margin options for css
* - code commented
*
* Version 2.0:
*  - choose between CSS or Tables (see settings below)
*  - Show Storycount & Submissioncount (depending on config.php setting)
*
* Version 1.0-jbothe-fix - www.okanagangirlz.com - destr0yr AT destr0yr DOT com
* - USE! "PHP (return)" :)
* - Removed all escapes for quotes (ie. "\"") and used '
* - Remove {}'s around $_CONF
* - All HTML is lower-case (XHTML compliant)
* - Added /> to img and br tags
* - Added border="0" to img tag
*
* Version 1.0 initial verison
*
* Serving suggestions:
* 1. If you have a LOT of topics on your page, and dont want to list them all in the
* topic menu, just remove the topics-block and put the menu entry of this static page
*  somewhere.
*
* 2. Enter the URL of this static page into the Help-URL of the topics-block.
*******************************************************************************/
# ICON DIMENSIONS
$maxwidth=false; # set either one to a number or to false
$maxheight=30; # if you set a number to both, you will distort your icons!

# SHOW TEXT?
$showtext=false;
$textbelow=true; # if true, text will be in the next line. if False, left of the icon.
$fontsize="7px";

# REWRAP SETTINGS
$rewrapcount=true; # rewrap line before story/submissioncount
$usetable=true;  # do you want to use CSS ot tables?
 	             #  if you use tables, the content can be aligned with the font properly
	             #  to the bottom of each 'box'.
	             #  if you do not use tables, and a high row-number, you have the most flexible
	             #  design for many diffferent users screenwidths and many topics.
$rownum=40;  # how many fields until rewrap? If usetable=false,
			#   and you set this high, the rewrap will be automatic

# Set this if $usetable=false
$lineheight="41px"; # set both of these to have a proper wrapping.
$boxwidth="41px";   #   if too small, the next line might not start at left side
					 #   but somewhere in the middle
$r_margin="1px";    # margin of the box, right side
$b_margin="1px";    # margin of the box, bottom

# No need to change behind this line -------------------------------------------

global $_TABLES, $_CONF;
if ($usetable) # start the table, align the table and position elements
	{$out='<table style="text-align:center;" align="center"><tr>';}

if ($_CONF['showstorycount']) # count the stories of each topic if set in config.php
    {
    $sql_count = "SELECT tid, count(*) AS count FROM {$_TABLES['stories']} "
         . 'WHERE (draft_flag = 0) AND (date <= NOW()) '.COM_getPermSQL('AND').' GROUP BY tid';
    $rcount=DB_query($sql_count);
    while($C=DB_fetchArray($rcount))
        {$storycount[$C['tid']] = $C['count'];}
    }

if ($_CONF['showsubmissioncount']) # count submissions if wanted
    {
    $sql_count="SELECT tid, count(*) AS count FROM {$_TABLES['storysubmission']} GROUP BY tid";
    $rcount=DB_query($sql_count);
    while($C=DB_fetchArray($rcount))
        {$submissioncount[$C['tid']]=$C['count'];}
    }

$sql="SELECT * FROM {$_TABLES['topics']} ".COM_getPermSQL(); # get all allowed topics

if ($_CONF['sortmethod']=='alpha')  # sort topics according to config.php setting
    {$sql.=' ORDER BY topic ASC;';}
else
    {$sql.=' ORDER BY sortnum;';}

$result=DB_query($sql);
for($i=0;$i<DB_numRows($result);$i++) # start looping through topics
    {
    if (($count==$rownum))  # do we start a new line?
        {
        if ($usetable)  # rewrap for tables
        	{$out.='</tr>'."\n".'<tr>';}
        else            # and for CSS
         	{$out.="\n".'<div style="clear:left;"></div>'."\n";}
        $count=0;
        }

    $B=DB_fetchArray($result, true); # get contents of Topic
	if($_CONF['showstorycount'] || $_CONF['showsubmissioncount']) # counter-display
        {
        # do we wrap counter to the next line?
        if ($rewrapcount) {$countstring="<BR>";} else {$countstring="&nbsp;";}
        $countstring.='(';
        if($_CONF['showstorycount'])
            {
            if(empty($storycount[$B['tid']])) {$countstring.=0;}
            else {$countstring.=$storycount[$B['tid']];}
            }

        if($_CONF['showsubmissioncount'])
            {
            if($_CONF['showstorycount']) {$countstring.='/';}
            if(empty( $submissioncount[$B['tid']])) {$countstring.=0;}
            else {$countstring.=$submissioncount[$B['tid']];}
            }
        $countstring.=')';
        }

    if ($usetable) # start new box with content
    	{$out.='<td style="vertical-align:bottom;">';}
    else           # same for CSS-Style
    	{          # if the boxes are not all the same size, left-float will get
        		   # 'stuck' on a larger box.
        $out.='<div style="float:left; text-align:center; margin-right:'.$r_margin.'; '
             .'margin-bottom:'.$b_margin.'; height:'.$lineheight.'; width:'.$boxwidth.';">';
        }

    $out.='<a href="'.$_CONF['site_url'].'/index.php?topic='.$B[0].'">'; # link
    $dimensions="";
    if ($maxheight>0) {$dimensions.="height='$maxheight'";}
    if ($maxwidth>0) {$dimensions.="width='$maxwidth'";}
    if (!empty($B['imageurl'])) # is there an image at all? if yes, display
    	{$out.='<img src="'.$_CONF['site_url'].$B[2].'" alt="'.$B[1].'" border="0" '.$dimensions.'>';}
    if ($textbelow) {$out.="<br>";}
    if ($showtext) {$out.="<div style='font-size:".$fontsize.";'>".$B[1]."</div>";}
	$out.='</a>'."<div style='font-size:".$fontsize.";'>".$countstring."</div>";   # close link and add counter
    if ($usetable) 					   # close box
    	{$out.='</td>'."\n";}
    else
		{$out.='</div>'."\n";}
    $count++;                         # increase counter for wrapping
    }

if ($usetable)                        #close table
	{$out.='</tr></table>'."\n";}
else                                  # close CSS float:left
	{$out.='<div style="clear:left;"></div>'."\n";}
return $out;                          # return results.
?>